"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UtilsMessageHandler = void 0;
const core_1 = require("@zwave-js/core");
const error_1 = require("../error");
const command_1 = require("./command");
class UtilsMessageHandler {
    static async handle(message) {
        const { command } = message;
        switch (message.command) {
            case command_1.UtilsCommand.parseQRCodeString: {
                const qrProvisioningInformation = (0, core_1.parseQRCodeString)(message.qr);
                return { qrProvisioningInformation };
            }
            case command_1.UtilsCommand.tryParseDSKFromQRCodeString: {
                const dsk = (0, core_1.tryParseDSKFromQRCodeString)(message.qr);
                return { dsk };
            }
            default: {
                throw new error_1.UnknownCommandError(command);
            }
        }
    }
}
exports.UtilsMessageHandler = UtilsMessageHandler;
