"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMockDriver = void 0;
const events_1 = require("events");
class MockController extends events_1.EventEmitter {
    homeId = 1;
    nodes = new Map();
}
class MockDriver extends events_1.EventEmitter {
    controller = new MockController();
    ready = true;
    statisticsEnabled = true;
    async start() {
        this.emit("driver ready");
    }
    getLogConfig() {
        return {
            enabled: true,
            level: "debug",
            transports: [],
        };
    }
    updateLogConfig(config) { }
    updateUserAgent(additionalUserAgentComponents) { }
    updateOptions(options) { }
    async destroy() { }
}
const createMockDriver = () => new MockDriver();
exports.createMockDriver = createMockDriver;
