"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseArgs = void 0;
const minimist_1 = __importDefault(require("minimist"));
const parseArgs = (expectedKeys) => {
    const args = (0, minimist_1.default)(process.argv.slice(2));
    const extraKeys = Object.keys(args).filter((key) => !expectedKeys.includes(key));
    if (extraKeys.length > 0) {
        console.error(`Error: Got unexpected keys ${extraKeys.join(", ")}`);
        process.exit(1);
    }
    return args;
};
exports.parseArgs = parseArgs;
