"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.determineNIF = void 0;
const safe_1 = require("@zwave-js/core/safe");
function determineNIF() {
    const basicDeviceClass = 0x02; // Static Controller
    const genericDeviceClass = 0x01; // Generic Controller
    const specificDeviceClass = 0x00; // Not used
    // When included securely, the NIF must only contain CCs that must ALWAYS be supported
    // Since we have no way to change it without factory reset, just advertise the minimum.
    return {
        basicDeviceClass,
        genericDeviceClass,
        specificDeviceClass,
        supportedCCs: [
            safe_1.CommandClasses["Z-Wave Plus Info"],
            safe_1.CommandClasses.Security,
            safe_1.CommandClasses["Security 2"],
            safe_1.CommandClasses["Transport Service"],
            safe_1.CommandClasses.Supervision,
            safe_1.CommandClasses["CRC-16 Encapsulation"],
            safe_1.CommandClasses["Multi Command"],
            safe_1.CommandClasses["Inclusion Controller"],
        ],
        // CC:0000.00.00.12.004: It is NOT RECOMMENDED to advertise controlled Command Classes.
        controlledCCs: [],
    };
}
exports.determineNIF = determineNIF;
//# sourceMappingURL=NodeInformationFrame.js.map