"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetLongRangeNodesResponse = exports.GetLongRangeNodesRequest = void 0;
const core_1 = require("@zwave-js/core");
const serial_1 = require("@zwave-js/serial");
let GetLongRangeNodesRequest = class GetLongRangeNodesRequest extends serial_1.Message {
    constructor(host, options) {
        super(host, options);
        if ((0, serial_1.gotDeserializationOptions)(options)) {
            this.segmentNumber = this.payload[0];
        }
        else {
            this.segmentNumber = options.segmentNumber;
        }
    }
    segmentNumber;
    serialize() {
        this.payload = Buffer.from([this.segmentNumber]);
        return super.serialize();
    }
};
exports.GetLongRangeNodesRequest = GetLongRangeNodesRequest;
exports.GetLongRangeNodesRequest = GetLongRangeNodesRequest = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Request, serial_1.FunctionType.GetLongRangeNodes),
    (0, serial_1.expectedResponse)(serial_1.FunctionType.GetLongRangeNodes),
    (0, serial_1.priority)(core_1.MessagePriority.Controller)
], GetLongRangeNodesRequest);
let GetLongRangeNodesResponse = class GetLongRangeNodesResponse extends serial_1.Message {
    constructor(host, options) {
        super(host, options);
        if ((0, serial_1.gotDeserializationOptions)(options)) {
            this.moreNodes = this.payload[0] != 0;
            this.segmentNumber = this.payload[1];
            const listLength = this.payload[2];
            const listStart = 3;
            const listEnd = listStart + listLength;
            if (listEnd <= this.payload.length) {
                const nodeBitMask = this.payload.subarray(listStart, listEnd);
                this.nodeIds = (0, core_1.parseLongRangeNodeBitMask)(nodeBitMask, this.listStartNode());
            }
            else {
                this.nodeIds = [];
            }
        }
        else {
            this.moreNodes = options.moreNodes;
            this.segmentNumber = options.segmentNumber;
            this.nodeIds = options.nodeIds;
        }
    }
    moreNodes;
    segmentNumber;
    nodeIds;
    serialize() {
        this.payload = Buffer.allocUnsafe(3 + core_1.NUM_LR_NODEMASK_SEGMENT_BYTES);
        this.payload[0] = this.moreNodes ? 1 : 0;
        this.payload[1] = this.segmentNumber;
        this.payload[2] = core_1.NUM_LR_NODEMASK_SEGMENT_BYTES;
        const nodeBitMask = (0, core_1.encodeLongRangeNodeBitMask)(this.nodeIds, this.listStartNode());
        nodeBitMask.copy(this.payload, 3);
        return super.serialize();
    }
    listStartNode() {
        return 256 + core_1.NUM_LR_NODES_PER_SEGMENT * this.segmentNumber;
    }
};
exports.GetLongRangeNodesResponse = GetLongRangeNodesResponse;
exports.GetLongRangeNodesResponse = GetLongRangeNodesResponse = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Response, serial_1.FunctionType.GetLongRangeNodes)
], GetLongRangeNodesResponse);
//# sourceMappingURL=GetLongRangeNodesMessages.js.map