"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetLongRangeChannelResponse = exports.SetLongRangeChannelRequest = exports.GetLongRangeChannelResponse = exports.GetLongRangeChannelRequest = void 0;
const core_1 = require("@zwave-js/core");
const core_2 = require("@zwave-js/core");
const serial_1 = require("@zwave-js/serial");
const shared_1 = require("@zwave-js/shared");
let GetLongRangeChannelRequest = class GetLongRangeChannelRequest extends serial_1.Message {
};
exports.GetLongRangeChannelRequest = GetLongRangeChannelRequest;
exports.GetLongRangeChannelRequest = GetLongRangeChannelRequest = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Request, serial_1.FunctionType.GetLongRangeChannel),
    (0, serial_1.expectedResponse)(serial_1.FunctionType.GetLongRangeChannel),
    (0, serial_1.priority)(core_1.MessagePriority.Controller)
], GetLongRangeChannelRequest);
let GetLongRangeChannelResponse = class GetLongRangeChannelResponse extends serial_1.Message {
    constructor(host, options) {
        super(host, options);
        this.channel = this.payload[0];
        if (this.payload.length >= 2) {
            this.supportsAutoChannelSelection =
                !!(this.payload[1] & 0b0001_0000);
            this.autoChannelSelectionActive = !!(this.payload[1] & 0b0010_0000);
        }
        else {
            this.supportsAutoChannelSelection = false;
            this.autoChannelSelectionActive = false;
        }
    }
    channel;
    supportsAutoChannelSelection;
    autoChannelSelectionActive;
};
exports.GetLongRangeChannelResponse = GetLongRangeChannelResponse;
exports.GetLongRangeChannelResponse = GetLongRangeChannelResponse = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Response, serial_1.FunctionType.GetLongRangeChannel),
    (0, serial_1.priority)(core_1.MessagePriority.Controller)
], GetLongRangeChannelResponse);
let SetLongRangeChannelRequest = class SetLongRangeChannelRequest extends serial_1.Message {
    constructor(host, options) {
        super(host, options);
        if ((0, serial_1.gotDeserializationOptions)(options)) {
            throw new core_1.ZWaveError(`${this.constructor.name}: deserialization not implemented`, core_1.ZWaveErrorCodes.Deserialization_NotImplemented);
        }
        else {
            this.channel = options.channel;
        }
    }
    channel;
    serialize() {
        this.payload = Buffer.from([this.channel]);
        return super.serialize();
    }
    toLogEntry() {
        return {
            ...super.toLogEntry(),
            message: {
                channel: (0, shared_1.getEnumMemberName)(core_2.LongRangeChannel, this.channel),
            },
        };
    }
};
exports.SetLongRangeChannelRequest = SetLongRangeChannelRequest;
exports.SetLongRangeChannelRequest = SetLongRangeChannelRequest = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Request, serial_1.FunctionType.SetLongRangeChannel),
    (0, serial_1.priority)(core_1.MessagePriority.Controller),
    (0, serial_1.expectedResponse)(serial_1.FunctionType.SetLongRangeChannel)
], SetLongRangeChannelRequest);
let SetLongRangeChannelResponse = class SetLongRangeChannelResponse extends serial_1.Message {
    constructor(host, options) {
        super(host, options);
        this.success = this.payload[0] !== 0;
    }
    isOK() {
        return this.success;
    }
    success;
    toLogEntry() {
        return {
            ...super.toLogEntry(),
            message: { success: this.success },
        };
    }
};
exports.SetLongRangeChannelResponse = SetLongRangeChannelResponse;
exports.SetLongRangeChannelResponse = SetLongRangeChannelResponse = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Response, serial_1.FunctionType.SetLongRangeChannel)
], SetLongRangeChannelResponse);
//# sourceMappingURL=LongRangeChannelMessages.js.map