"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetLongRangeShadowNodeIDsRequest = void 0;
const core_1 = require("@zwave-js/core");
const serial_1 = require("@zwave-js/serial");
const LONG_RANGE_SHADOW_NODE_IDS_START = 2002;
const NUM_LONG_RANGE_SHADOW_NODE_IDS = 4;
let SetLongRangeShadowNodeIDsRequest = class SetLongRangeShadowNodeIDsRequest extends serial_1.Message {
    constructor(host, options) {
        super(host, options);
        if ((0, serial_1.gotDeserializationOptions)(options)) {
            this.shadowNodeIds = (0, core_1.parseBitMask)(this.payload.subarray(0, 1), LONG_RANGE_SHADOW_NODE_IDS_START, NUM_LONG_RANGE_SHADOW_NODE_IDS);
        }
        else {
            this.shadowNodeIds = options.shadowNodeIds;
        }
    }
    shadowNodeIds;
    serialize() {
        this.payload = Buffer.allocUnsafe(1);
        this.payload = (0, core_1.encodeBitMask)(this.shadowNodeIds, LONG_RANGE_SHADOW_NODE_IDS_START
            + NUM_LONG_RANGE_SHADOW_NODE_IDS
            - 1, LONG_RANGE_SHADOW_NODE_IDS_START);
        return super.serialize();
    }
};
exports.SetLongRangeShadowNodeIDsRequest = SetLongRangeShadowNodeIDsRequest;
exports.SetLongRangeShadowNodeIDsRequest = SetLongRangeShadowNodeIDsRequest = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Request, serial_1.FunctionType.SetLongRangeShadowNodeIDs),
    (0, serial_1.priority)(core_1.MessagePriority.Controller)
], SetLongRangeShadowNodeIDsRequest);
//# sourceMappingURL=SetLongRangeShadowNodeIDsRequest.js.map