"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SendTestFrameTransmitReport = exports.SendTestFrameResponse = exports.SendTestFrameRequest = exports.SendTestFrameRequestBase = void 0;
const cc_1 = require("@zwave-js/cc");
const core_1 = require("@zwave-js/core");
const serial_1 = require("@zwave-js/serial");
const shared_1 = require("@zwave-js/shared");
let SendTestFrameRequestBase = class SendTestFrameRequestBase extends serial_1.Message {
    constructor(host, options) {
        if ((0, serial_1.gotDeserializationOptions)(options)
            && new.target !== SendTestFrameTransmitReport) {
            return new SendTestFrameTransmitReport(host, options);
        }
        super(host, options);
    }
};
exports.SendTestFrameRequestBase = SendTestFrameRequestBase;
exports.SendTestFrameRequestBase = SendTestFrameRequestBase = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Request, serial_1.FunctionType.SendTestFrame),
    (0, serial_1.priority)(core_1.MessagePriority.Normal)
], SendTestFrameRequestBase);
let SendTestFrameRequest = class SendTestFrameRequest extends SendTestFrameRequestBase {
    constructor(host, options) {
        super(host, options);
        if ((0, serial_1.gotDeserializationOptions)(options)) {
            let offset = 0;
            const { nodeId, bytesRead: nodeIdBytes } = (0, core_1.parseNodeID)(this.payload, host.nodeIdType, offset);
            offset += nodeIdBytes;
            this.testNodeId = nodeId;
            this.powerlevel = this.payload[offset++];
            this.callbackId = this.payload[offset++];
        }
        else {
            this.testNodeId = options.testNodeId;
            this.powerlevel = options.powerlevel;
        }
    }
    testNodeId;
    powerlevel;
    serialize() {
        const nodeId = (0, core_1.encodeNodeID)(this.testNodeId, this.host.nodeIdType);
        this.payload = Buffer.concat([
            nodeId,
            Buffer.from([
                this.powerlevel,
                this.callbackId,
            ]),
        ]);
        return super.serialize();
    }
    toLogEntry() {
        return {
            ...super.toLogEntry(),
            message: {
                "test node id": this.testNodeId,
                powerlevel: (0, shared_1.getEnumMemberName)(cc_1.Powerlevel, this.powerlevel),
                "callback id": this.callbackId,
            },
        };
    }
};
exports.SendTestFrameRequest = SendTestFrameRequest;
exports.SendTestFrameRequest = SendTestFrameRequest = __decorate([
    (0, serial_1.expectedResponse)(serial_1.FunctionType.SendTestFrame),
    (0, serial_1.expectedCallback)(serial_1.FunctionType.SendTestFrame)
], SendTestFrameRequest);
let SendTestFrameResponse = class SendTestFrameResponse extends serial_1.Message {
    constructor(host, options) {
        super(host, options);
        this.wasSent = this.payload[0] !== 0;
    }
    wasSent;
    toLogEntry() {
        return {
            ...super.toLogEntry(),
            message: { "was sent": this.wasSent },
        };
    }
};
exports.SendTestFrameResponse = SendTestFrameResponse;
exports.SendTestFrameResponse = SendTestFrameResponse = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Response, serial_1.FunctionType.SendTestFrame)
], SendTestFrameResponse);
class SendTestFrameTransmitReport extends SendTestFrameRequestBase {
    constructor(host, options) {
        super(host, options);
        this.callbackId = this.payload[0];
        this.transmitStatus = this.payload[1];
    }
    transmitStatus;
    isOK() {
        return this.transmitStatus === core_1.TransmitStatus.OK;
    }
    toLogEntry() {
        return {
            ...super.toLogEntry(),
            message: {
                "callback id": this.callbackId,
                "transmit status": (0, shared_1.getEnumMemberName)(core_1.TransmitStatus, this.transmitStatus),
            },
        };
    }
}
exports.SendTestFrameTransmitReport = SendTestFrameTransmitReport;
//# sourceMappingURL=SendTestFrameMessages.js.map